Описание публичного интерфейса библиотеки
========================
<!-- TOC -->

- [Стандартная библиотека шагов](#стандартная-библиотека-шагов)
    - [Управление файлами и каталогами](#управление-файлами-и-каталогами)
        - [Постоянные и временные каталоги](#постоянные-и-временные-каталоги)
        - [Создание каталогов](#создание-каталогов)
        - [Создание файлов](#создание-файлов)
        - [Создание и анализ файлов с нужным текстом](#создание-и-анализ-файлов-с-нужным-текстом)
        - [Копирование файлов и каталогов](#копирование-файлов-и-каталогов)
        - [Удаление каталогов и файлов](#удаление-каталогов-и-файлов)
        - [Проверка существования каталогов и файлов](#проверка-существования-каталогов-и-файлов)

<!-- /TOC -->

<a id="markdown-стандартная-библиотека-шагов" name="стандартная-библиотека-шагов"></a>
## Стандартная библиотека шагов

>для использования в собственных фичах

Стандартные библиотечные шаги, подключаемые автоматически для любой фичи, находятся в каталоге `features/libraries/Файлы`

- `Файловые операции.feature` - создание файлов/каталогов, их копирование, анализ содержимого файлов

### Управление файлами и каталогами

<a id="markdown-постоянные-и-временные-каталоги" name="постоянные-и-временные-каталоги"></a>
#### Постоянные и временные каталоги

- `И Я сохраняю каталог проекта в контекст`
- `Дано Я создаю временный каталог и сохраняю его в переменной "СпециальныйКаталог"`
- `Допустим Я создаю временный каталог и сохраняю его в контекст`
- `И Я устанавливаю временный каталог как рабочий каталог`
- `И Я установил подкаталог "folder0" рабочего каталога как текущий каталог`

- `И Я показываю текущий каталог`
- `Тогда Я показываю каталог проекта`
- `И Я показываю рабочий каталог`

<a id="markdown-создание-каталогов" name="создание-каталогов"></a>
#### Создание каталогов

- `И Я создаю каталог "folder0/folder01" в рабочем каталоге`
- `И Я создаю каталог "folder011" в подкаталоге "folder0/folder01" рабочего каталога`

- `Когда Я создаю каталог "СпециальныйКаталог/folder0/folder01"`
- `Когда Я создаю каталог "folder1/folder11" внутри каталога "СпециальныйКаталог"`

- `Допустим Я создаю временный каталог и сохраняю его в контекст`

<a id="markdown-создание-файлов" name="создание-файлов"></a>
#### Создание файлов

- `Когда Я создаю файл "folder0/file01.txt" в рабочем каталоге`
- `И Я создаю файл "file01" в подкаталоге "folder0/folder01" рабочего каталога`

- `Когда Я создаю файл "СпециальныйКаталог/file01.txt"`

- `Когда Я создаю файл "folder1/file11.txt" внутри каталога "СпециальныйКаталог"`
- `Тогда Файл "СпециальныйКаталог/folder1/file11.txt" существует`

<a id="markdown-создание-и-анализ-файлов-с-нужным-текстом" name="создание-и-анализ-файлов-с-нужным-текстом"></a>
#### Создание и анализ файлов с нужным текстом

- `Когда Я создаю файл "СпециальныйКаталог/ФайлСТекстом.txt" с текстом "текст178"`
- `Тогда Файл "СпециальныйКаталог/ФайлСТекстом.txt" содержит "178"`

- `Когда Я создаю файл "СпециальныйКаталог/ФайлСТекстом.txt" с текстом`

```gherkin
        Когда Я создаю файл "СпециальныйКаталог/ФайлСТекстом.txt" с текстом
        """
            строка 1
            строка 2
        """
        Тогда Файл "СпециальныйКаталог/ФайлСТекстом.txt" содержит
        """
            строка 1
            строка 2
        """
```

- `Тогда Файл "folder0/file01.txt" содержит "Текст файла"`
- `И Файл "folder0/file01.txt" не содержит "Не существующий текст"`

- `Тогда Файл "folder0/file01.txt" в рабочем каталоге содержит "Текст файла"`
- `И Файл "folder0/file01.txt" в рабочем каталоге не содержит "Не существующий текст"`

<a id="markdown-копирование-файлов-и-каталогов" name="копирование-файлов-и-каталогов"></a>
#### Копирование файлов и каталогов

- `Когда Я копирую файл "step_definitions/БезПараметров.os" из каталога "tests/fixtures" проекта в рабочий каталог`
- `И Я копирую файл "fixtures/test-report.xml" из каталога "tests" проекта в подкаталог "folder0/folder01" рабочего каталога`

- `Когда Я копирую каталог "fixtures/step_definitions" из каталога "tests/fixtures" проекта в рабочий каталог`
- `И Я копирую каталог "fixtures/step_definitions" из каталога "tests" проекта в подкаталог "folder0/folder01" рабочего каталога`

<a id="markdown-удаление-каталогов-и-файлов" name="удаление-каталогов-и-файлов"></a>
#### Удаление каталогов и файлов

- `Когда Я удаляю каталог "СпециальныйКаталог/КаталогДляУдаления"`
- `Когда Я удаляю файл "СпециальныйКаталог/ФайлДляУдаления.txt"`

<a id="markdown-проверка-существования-каталогов-и-файлов" name="проверка-существования-каталогов-и-файлов"></a>
#### Проверка существования каталогов и файлов

- `Тогда Каталог "СпециальныйКаталог/folder0" существует`
    - или `Тогда Каталог "СпециальныйКаталог/folder0/folder01" существует`

-  `И Каталог "СпециальныйКаталог/folder0/folder01-unknown" не существует`

- `Тогда Файл "СпециальныйКаталог/file01.txt" существует`
- `И Файл "folder01/file01-unknown.txt" не существует`

- `Тогда В рабочем каталоге существует каталог "folder0/folder01"`
- `И В подкаталоге "folder0/folder01" рабочего каталога существует каталог "folder011"`
- `И В подкаталоге "folder0/folder01" рабочего каталога существует каталог "*011"`

- `Тогда Каталог "folder0" внутри каталога "СпециальныйКаталог" существует`
    - или `И Каталог "folder0/folder01" внутри каталога "СпециальныйКаталог" существует`

- `И Каталог "folder0/folder01-unknown" внутри каталога "СпециальныйКаталог" не существует`

- `Тогда В рабочем каталоге существует файл "folder0/file01.txt"`
    - или `Тогда В рабочем каталоге существует файл "folder0/*01.txt"`
- `И В подкаталоге "folder0/folder01" рабочего каталога существует файл "file01"`
    - или `И В подкаталоге "folder0/folder01" рабочего каталога существует файл "*01"`
