<a id="markdown-генераторы-отчетов-о-результатах-тестирования" name="генераторы-отчетов-о-результатах-тестирования"></a>
# Генераторы отчетов о результатах тестирования

<!-- TOC -->

- [Генераторы отчетов о результатах тестирования](#генераторы-отчетов-о-результатах-тестирования)
    - [ГенераторОтчетаJUnitXML](#генераторотчетаjunitxml)
    - [ГенераторОтчетаAllureXMLВерсия2](#генераторотчетаallurexmlверсия2)
    - [(устаревший) ГенераторОтчетаAllureXML](#устаревший-генераторотчетаallurexml)
    - [ГенераторОтчетаMXL](#генераторотчетаmxl)
    - [Использование при запуске](#использование-при-запуске)
        - [Задание в json-файле настройки (лучший способ)](#задание-в-json-файле-настройки-лучший-способ)
        - [Задание в строке запуска 1С (не рекомендуется)](#задание-в-строке-запуска-1с-не-рекомендуется)

<!-- /TOC -->

Плагины данных видов выполняют задачу формирования отчетов о результатах тестирования

Для использования в интерактивном режиме и при запуске в режиме командной строки.

Данные плагины полезно использовать на серверах сборок (серверы непрерывной интеграции, CI-серверы)

<a id="markdown-генераторотчетаjunitxml" name="генераторотчетаjunitxml"></a>
## ГенераторОтчетаJUnitXML

Плагин формирует отчет в виде файла специального формата `JUNIT.xml (версии 4)`, который поддерживается в разных средах разработки и серверах сборки.

Формируется 2-уровневая структура - контейнер тестов и сам тест.

<a id="markdown-генераторотчетаallurexmlверсия2" name="генераторотчетаallurexmlверсия2"></a>
## ГенераторОтчетаAllureXMLВерсия2

Плагин формирует отчет в специальном xml-формате для фреймворка `Yandex.Allure (версии 2)`, который также поддерживается в разных средах разработки и серверах сборки.

Формируется 3-уровневая структура - 2 уровня контейнеров тестов и сам тест.

Далее результаты можно посмотреть в Allure 2 (если он установлен)

Выполнение команды по очереди (allure уже должен быть прописан в PATH):

- при условии генерации отчета в каталог `C:\myproject\allure`

```cmd
cd /d C:\myproject
allure generate allure
allure open
```

Пример вывода результатов с группировкой

- Если для дымовых тестов включена группировка по метаданным в файле настроек - "СпособГруппировки":"ПоВидуМетаданных"

  ![](/doc/images/results-Allure2.png)

- Если для дымовых тестов включена группировка по виду метаданного в файле настроек - "СпособГруппировки":"ПоВидуОбъекта"

  ![](/doc/images/results-Allure2-Group-by-Single-Metadata.png)

<!-- ![](./doc/images/MakeAutoVideo.png) -->

<a id="markdown-устаревший-генераторотчетаallurexml" name="устаревший-генераторотчетаallurexml"></a>
## (устаревший) ГенераторОтчетаAllureXML

Плагин формирует отчет в специальном xml-формате для фреймворка `Yandex.Allure (версии 1)`, который также поддерживается в разных средах разработки и серверах сборки.

Формируется только устаревшая 2-уровневая структура - контейнер тестов и сам тест.

Далее результаты можно посмотреть в Allure 2, как написано выше

<a id="markdown-генераторотчетаmxl" name="генераторотчетаmxl"></a>
## ГенераторОтчетаMXL

Плагин формирует отчет в 1С-формате `mxl` - табличный документ.

В основном, используется при интерактивной работе для немедленного показа результата тестированию пользователю, выполнявшему прогон тестов.

<a id="markdown-использование-при-запуске" name="использование-при-запуске"></a>
## Использование при запуске

<a id="markdown-задание-в-json-файле-настройки-лучший-способ" name="задание-в-json-файле-настройки-лучший-способ"></a>
### Задание в json-файле настройки (лучший способ)

При использовании запуска тестов через [Vanessa-Runner](https://github.com/vanessa-opensource/vanessa-runner) в файле vrunner.json нужно указать использование плагинов следующим образом:

```json
"--reportsxunit": "ГенераторОтчетаJUnitXML{build/junit.xml};
ГенераторОтчетаAllureXMLВерсия2{build/allure/allure.xml}"
```

<a id="markdown-задание-в-строке-запуска-1с-не-рекомендуется" name="задание-в-строке-запуска-1с-не-рекомендуется"></a>
### Задание в строке запуска 1С (не рекомендуется)

```cmd
"C:\Program Files\1cv8\8.3.10.2580\bin\1cv8.exe" ENTERPRISE /F"D:\ibService"
/Nadmin /P1 /RunModeManagedApplication /Execute "C:\Program Files (x86)\OneScript\lib\add\xddTestRunner.epf"
/C "xddRun ЗагрузчикКаталога ""D:\Tests"";
xddReports ГенераторОтчетаJUnitXML{build/junit.xml};
ГенераторОтчетаAllureXMLВерсия2{build/allure/allure.xml};
xddShutdown;"
```
