# Запросы из БД  

Плагин "Запросы из БД" предназначен для получения данных из информационной базы, базы данных.
В режиме сервера или толстого клиента обычного приложения.

- [Примеры](#примеры)
  - [Пример получения количества документов по отбору](#пример-получения-количества-документов-по-отбору)
  - [Пример получения количества элементов справочника по отбору](#пример-получения-количества-элементов-справочника-по-отбору)
  - [Пример получения количества элементов метаданного по отбору](#пример-получения-количества-элементов-метаданного-по-отбору)
  - [Пример получения элементов метаданного по отбору](#пример-получения-элементов-метаданного-по-отбору)
  
## Примеры

### Получение количества документов по отбору

```bsl
ВидДокумента = "ПриходнаяНакладная";
ДатаНачала = Дата('20210509125531');
ДатаОкончания = Дата('20210510125531');

Отбор = Новый Структура;
Отбор.Вставить("Склад", Склад);

КоличествоДокументов = ЗапросыИзБД.ПолучитьКоличествоДокументовПоОтбору(ВидДокумента, ДатаНачала, ДатаОкончания, Отбор);
```

### Получение количества элементов справочника по отбору

```bsl
ВидСправочника = "ПростойСправочник";

Отбор = Новый Структура;
Отбор.Вставить("РеквизитБулево", Истина);

КоличествоЭлементовСправочника = ЗапросыИзБД.ПолучитьКоличествоЭлементовСправочникаПоОтбору(ВидСправочника, Отбор);
```
### Получение количества элементов метаданного по отбору

```bsl
ТипМетаданного = "Документ";
ВидМетаданного = "ПриходнаяНакладная";

Отбор = Новый Структура;
Отбор.Вставить("Склад", _Склад);

КоличествоЭлементовМетаданного = ЗапросыИзБД.ПолучитьКоличествоЭлементовМетаданногоПоОтбору(ТипМетаданного, ВидМетаданного, Отбор);
```

### Получение элементов метаданного по отбору

```bsl
ТипМетаданного = "Документ";
ВидМетаданного = "ПриходнаяНакладная";
КоличествоЭлементов = 3;

СтруктураОтбора = Новый Структура;
СтруктураОтбора.Вставить("Склад", _Склад);

КоличествоЭлементовМетаданного = ЗапросыИзБД.ПолучитьКоличествоЭлементовМетаданногоПоОтбору(ТипМетаданного, ВидМетаданного, КоличествоЭлементов, СтруктураОтбора);
```
