<a id="markdown-проверки--утверждения-vanessaadd" name="проверки--утверждения-vanessaadd"></a>
# Проверки / утверждения Vanessa.ADD

<!-- TOC -->

- [Проверки / утверждения Vanessa.ADD](#проверки--утверждения-vanessaadd)
    - [Пример вызова утверждений из тестов:](#пример-вызова-утверждений-из-тестов)
        - [Обращение к плагинам](#обращение-к-плагинам)
    - [Плагины для вызова утверждений](#плагины-для-вызова-утверждений)

<!-- /TOC -->

В своих тестах можно использовать различные универсальные методы проверки состояний, значений, т.н. **утверждения**.

Согласно [Принципам написания тестов](Принципы-написания-тестов.MD) использование утверждений очень полезно использовать в своих тестах.

<a id="markdown-пример-вызова-утверждений-из-тестов" name="пример-вызова-утверждений-из-тестов"></a>
## Пример вызова утверждений из тестов:

```bsl
  Ожидаем.Что(НекийМассив.Количество(), "Ожидали 9 элементов, но это не так")
      .Минимум(9);

  Ожидаем.Что(НекийМассив.Количество(), "Ожидали 9 элементов, но это не так")
      .ЭтоНе()
      .Равно(9);
```

или 

```bsl
  Утверждения.Проверить(успешно, "флаг успешно");
  Утверждения.ПроверитьРавенство(1, Таб.Количество(), "Таб.Количество()");
  Утверждения.ПроверитьЗаполненность(Таб, "Таб");
```

В каждом из методов-утверждений есть специальный последний параметр по умолчанию **ДопСообщениеОшибки = ""**

В этом параметре можно передать специальный текст для большей детализации ошибочного сообщения и возможного поиска строки, вызвавшей ошибку, в своем коде.

<a id="markdown-обращение-к-плагинам" name="обращение-к-плагинам"></a>
### Обращение к плагинам 

* Из кода шагов (BDD), запускаемых через `bddRunner`

```bsl
  Утверждения = Ванесса.Плагин("БазовыеУтверждения");
  Ожидаем = Ванесса.Плагин("УтвержденияBDD");
```

* Из кода тестов (TDD), запускаемых через `xddTestRunner`

```bsl
  Утверждения = КонтекстЯдра.Плагин("БазовыеУтверждения");
  Ожидаем = КонтекстЯдра.Плагин("УтвержденияBDD");
```

<a id="markdown-плагины-для-вызова-утверждений" name="плагины-для-вызова-утверждений"></a>
## Плагины для вызова утверждений

- [Базовые утверждения](Базовые-утверждения.MD) - простые, но мощные утверждения.
- [Текучие (fluent) утверждения](Текучие-(fluent)-утверждения.MD) - очень красивые и довольно удобные. Можно выполнять несколько проверок в одной строке проверки.
- [Проверка таблиц и табличных документов](Проверка-таблиц-и-табличных-документов.MD)
