# Пользовательские настройки

## Обращение к плагину (пример)

```bsl
Перем КонтекстЯдра;
Перем Настройки;

Процедура Инициализация(КонтекстЯдраПараметр) Экспорт
	
	КонтекстЯдра = КонтекстЯдраПараметр;
	Настройки = КонтекстЯдра.Плагин("Настройки");
	
КонецПроцедуры
```

## Использование плагина
Плагин предназначен для чтения пользовательских настроек из файла настроек, а так же для управления настройками и получения значений настроек.

Файл настроек должен быть в формате JSON. Пример файла настроек:
```json
{
    "ПолноеИмяФайлаТестируемойОбработки": "D:\\MyProject\\MyProcess.epf"
}
```

В браузере тестирования xddTrstRunner есть команда для подключения файла настроек  
`Загрузить - Загрузить настройки из файла...`  
Если настройки подключены, то в дальнейшем, используя программный интерфейс плагина можно получить настройки как коллекция. После чего возможно управление настройками и получение значений конкретных настроек.

## Методы интерфейса

`ПолучитьНастройки()` - процедура позволяет получить настройки из подключенного файла настроек. Настройки из файла загружаются в фиксированную структуру Настройки. Получение данных из этой структуры или добавление в нее новых настроек производится с применением методов программного интерфейса.

`ДобавитьНастройку(Ключ, Значение)` - процедура позволяет добавить настройку к текущим настройкам  
Параметры:  
Ключ - Строка - наименование добавляемой настройки  
Значение - Произвольное - значение добавляемой настройки

`ДобавитьНастройки(ИсточникНастроек)` - процедура позволяет добавить настройки к текущим настройкам  
Параметры:  
ИсточникНастроек - Структура | Фиксированная структура - коллекция с новыми настройками, которые нужно добавить к текущим настройкам

`ЕстьНастройка(ПутьНастроек, СтруктураНастроек)` - функция позволяет проверить, что настройка существует. Возвращает признак Настройка существует (Булево)  
Параметры:  
ПутьНастроек - Строка - Ключ настройки или путь до настройки, как строка ключей, разделенных точкой, например "Ключ1.Ключ2"  
СтруктураНастроек - Структура | Неопределено - исходная структура, которая содержит значение искомой настройки

`ЕстьЗначениеНастройки(ПутьНастроек, ЗначениеНастройки)` - функция позволяет получить значение настройки по указанному имени или пути, а также проверяет, имеется ли настройка по указанному пути. Возвращаемое значение - Булево - признак того, что настройка найдена  

Параметры:  
ПутьНастроек - Строка - Путь из ключей настройки, разделенных точкой, например: "Ключ1.Ключ2"  
ЗначениеНастройки - Произвольный - (выходной параметр) найденное значение настройки. Если ключа или пути из ключей нет в настройках, то возвращается Неопределено.
