# Версия 1.5.17

<a id="markdown-тесты" name="тесты"></a>

# Дымовые тесты 1С

- [Тесты](#тесты)
    - [Ссылки на каталоги](#каталоги)
    - [Введение](#введение)
    - [Описание тестов](#описание)
        - [Тесты для проверки объектов метаданных на соответствие стандартам 1C](#тесты_стандарты1с)
            - [1.1. Проверка стандартных ролей](#Тесты_ПроверкаСтандартныхРолей)
            - [1.2. Проверка общих реквизитов](#Тесты_ПроверкаОбщихРеквизитов)
            - [1.3. Проверка права интерактивно удаления](#Тесты_ПроверкаПраваИнтерактивногоУдаления)
            - [1.4. Проверка права интерактивно удаления помеченных](#Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных)
            - [1.5. Проверка прав на предопределенные данные объектов](#Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов)
            - [1.6. Проверка привилегированного режима объектов](#Тесты_ПроверкаПривилегированногоРежимаОбъектов)
            - [1.7. Проверка регламентных заданий](#Тесты_ПроверкаРегламентныхЗаданий)
            - [1.8. Проверка составных типов данных](#Тесты_ПроверкаСоставныхТиповДанных)
            - [1.9. Проверка синонима устаревших объектов метаданных](#Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных)
            - [1.10. Проверка прав к устаревшим объектам](#Тесты_ПроверкаПравКУстаревшимОбъектам)
            - [1.11. Проверка прав на чтение объектов](#Тесты_ПроверкаПравНаЧтениеОбъектов)
            - [1.12. Проверка пользовательских представлений новых объектов](#Тесты_ПроверкаПользовательскихПредставленийОбъектов)
            - [1.13. Проверка реквизитов документов: комментарий, ответственный](#Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный)
            - [1.14. Проверка включения объектов в командный интерфейс](#Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс)
        - [Тесты для проверки объектов метаданных на соответствие внутренним стандартам](#тесты_внутренние_стандарты)
            - [2.1. Проверка префикса в новых объектах и реквизитах](#Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах)
            - [2.2. Проверка включения новых объектов с префиксом в подсистему](#Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему)
            - [2.3. Проверка синонима новых объектов и реквизитов](#Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом)
            - [2.4. Проверка префикса свойств новых объектов](#Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов)
            - [2.5. Проверка основных форм отчетов](#Тесты_ПроверкаОсновныхФормОтчетов)
            - [2.6. Проверка хранилища вариантов отчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)
            - [2.7. Проверка прав на чтение объектов с RLS](#Тесты_ПроверкаПравНаЧтениеОбъектовRLS)
            - [2.8. Проверка макетов СКД внешних отчетов и обработок](#Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок)
            - [2.9. Проверка объектов метаданных конфигурации поставщика](#Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика)
            - [2.10. Проверка каноничности префикса новых объектов и реквизитов](#Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств)
            - [2.11. Проверка индексирования устаревших объектов метаданных](#Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных)
            - [2.12. Проверка устаревших типов данных](#Тесты_ПроверкаУстаревшихТиповДанных)
            - [2.13. Проверка авторегистрации планов обмена](#Тесты_ПроверкаАвтоРегистрацииПлановОбмена)
            - [2.14. Переход на управляемые формы](#Тесты_ПереходНаУправляемыеФормы)
            - [2.15. Проверка периодичности нумерации документов](#Тесты_ПроверкаПериодичностиНумерацииДокументов)
            - [2.16. Проверка регистров для отчета "Движения документа"](#Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента)
        - [Шаблон теста](#шаблон_теста)
    - [Настройка тестов](#настройка)

<a id="markdown-каталоги" name="каталоги"></a>

## Ссылки на каталоги

* [Исходники тестов](../../tests/smoke)
* [Файлы настроек тестов](../../tools/JSON)

<a id="markdown-введение" name="введение"></a>

## Введение

+ Тесты проверяют метаданные на соответствие внутренним стандартам и [стандартам 1С](https://its.1c.ru/db/v8std).
+ Тесты запускаются с помощью обработки [xddTestRunner](https://github.com/vanessa-opensource/add/tree/master/epf/xddTestRunner) проекта [Vanessa-ADD (Vanessa Automation Driven Development)](https://github.com/vanessa-opensource/add).

<a id="markdown-описание" name="описание"></a>

## Описание тестов

<a id="markdown-тесты_стандарты1с" name="тесты_стандарты1с"></a>

### [1.](#тесты) Тесты для проверки объектов метаданных на соответствие [стандартам 1С](https://its.1c.ru/db/v8std)

<a id="markdown-Тесты_ПроверкаСтандартныхРолей" name="Тесты_ПроверкаСтандартныхРолей"></a>
+ **[1.1.]](#тесты) Проверка [стандартных ролей](https://its.1c.ru/db/v8std#content:488:hdoc)** 
([Тесты_ПроверкаСтандартныхРолей](./Тесты_ПроверкаСтандартныхРолей))

    + Тест проверяет состав основных ролей конфигурации, типовые роли и права на корень конфигурации, остальные роли и права на корень конфигурации.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [Основные роли](#Настройки_ОсновныеРоли)
        - [Стандартные роли](#Настройки_СтандартныеРоли)

<a id="markdown-Тесты_ПроверкаОбщихРеквизитов" name="Тесты_ПроверкаОбщихРеквизитов"></a>
+ **[1.2.](#тесты) Проверка [общих реквизитов](https://its.1c.ru/db/v8std#content:677:hdoc)** 
([Тесты_ПроверкаОбщихРеквизитов](./Тесты_ПроверкаОбщихРеквизитов))

    + Тест проверяет, что у общих реквизитов включено использование разделения данных.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаПраваИнтерактивногоУдаления" name="Тесты_ПроверкаПраваИнтерактивногоУдаления"></a>
+ **[1.3.](#тесты) Проверка [права интерактивно удаления](https://its.1c.ru/db/v8std#content:689:hdoc)** 
([Тесты_ПроверкаПраваИнтерактивногоУдаления](./Тесты_ПроверкаПраваИнтерактивногоУдаления))

    + Тест проверяет, что у ролей кроме основных нет права на интерактивное удаление объектов базы данных.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Проверять основные роли](#Настройки_ПроверятьОсновныеРоли)

<a id="markdown-Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных" name="Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных"></a>
+ **[1.4.](#тесты) Проверка [права интерактивно удаления помеченных](https://its.1c.ru/db/v8std#content:488:hdoc)** 
([Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных](./Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных))

    + Тест проверяет, что у ролей кроме основных нет права на интерактивное удаление помеченных объектов базы данных.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Проверять основные роли](#Настройки_ПроверятьОсновныеРоли)

<a id="markdown-Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов" name="Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов"></a>
+ **[1.5.](#тесты) Проверка [прав на предопределенные данные объектов](https://its.1c.ru/db/v8std#content:488:hdoc)** 
([Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов](./Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов))

    + Тест проверяет, что у ролей кроме основных нет следующих прав на предопределенные данные объектов:
        * Интерактивное удаление предопределенных данных
        * Интерактивная пометка удаления предопределенных данных
        * Интерактивное снятие пометки удаления предопределенных данных
        * Интерактивное удаление помеченных предопределенных данных
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Проверять основные роли](#Настройки_ПроверятьОсновныеРоли)

<a id="markdown-Тесты_ПроверкаПривилегированногоРежимаОбъектов" name="Тесты_ПроверкаПривилегированногоРежимаОбъектов"></a>
+ **[1.6.](#тесты) Проверка [привилегированного режима объектов](https://its.1c.ru/db/v8std#content:485:hdoc)** 
([Тесты_ПроверкаПривилегированногоРежимаОбъектов](./Тесты_ПроверкаПривилегированногоРежимаОбъектов))

    + Тест проверяет, что у объектов метаданных установлен привилегированный режим.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаРегламентныхЗаданий" name="Тесты_ПроверкаРегламентныхЗаданий"></a>
+ **[1.7.](#тесты) Проверка [регламентных заданий](https://its.1c.ru/db/v8std#content:540:hdoc)** 
([Тесты_ПроверкаРегламентныхЗаданий](./Тесты_ПроверкаРегламентныхЗаданий))

    + Тест проверяет, что у регламентного задания не установлен признак "Использование".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаСоставныхТиповДанных" name="Тесты_ПроверкаСоставныхТиповДанных"></a>
+ **[1.8.](#тесты) Проверка [составных типов данных](https://its.1c.ru/db/v8std#content:728:hdoc)** 
([Тесты_ПроверкаСоставныхТиповДанных](./Тесты_ПроверкаСоставныхТиповДанных))

    + Тест проверяет, что реквизиты и свойства объектов метаданных:
        * Не используют составной тип данных "ЛюбаяСсылка", "ДокументСсылка" и т.д.
        * Не содержат примитивных и ссылочных типов.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [Проверять дополнительные реквизиты](#Настройки_ПроверятьДополнительныеРеквизиты)
        - [Пропускать объекты с префиксом удалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)

<a id="markdown-Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных" name="Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных"></a>
+ **[1.9.](#тесты) Проверка [синонима устаревших объектов метаданных](https://its.1c.ru/db/v8std#content:534:hdoc)** 
([Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных](./Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных))

    + Тест проверяет, что у устаревших (с префиксом "Удалить") объектов и свойств метаданных синоним содержит префикс "(не используется)".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаПравКУстаревшимОбъектам" name="Тесты_ПроверкаПравКУстаревшимОбъектам"></a>
+ **[1.10.](#тесты) Проверка [прав к устаревшим объектам](https://its.1c.ru/db/v8std#content:689:hdoc)** 
([Тесты_ПроверкаПравКУстаревшимОбъектам](./Тесты_ПроверкаПравКУстаревшимОбъектам))

    + Тест проверяет, что у неосновных ролей нет прав на объекты метаданных с префиксом "Удалить".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаПравНаЧтениеОбъектов" name="Тесты_ПроверкаПравНаЧтениеОбъектов"></a>
+ **[1.11.](#тесты) Проверка прав на чтение объектов** 
([Тесты_ПроверкаПравНаЧтениеОбъектов](./Тесты_ПроверкаПравНаЧтениеОбъектов))

    + Тест проверяет, что у неосновных ролей есть право чтение объектов метаданных.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [ПропускатьОбъектыСПрефиксомУдалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)
        - РольБазовыеПрава - Имя роли с минимальными правами для первоначального поиска по этой роли.

<a id="markdown-Тесты_ПроверкаПользовательскихПредставленийОбъектов" name="Тесты_ПроверкаПользовательскихПредставленийОбъектов"></a>
+ **[1.12.](#тесты) Проверка [пользовательских представлений новых объектов](https://its.1c.ru/db/v8std#content:468:hdoc)** 
([Тесты_ПроверкаПользовательскихПредставленийОбъектов](./Тесты_ПроверкаПользовательскихПредставленийОбъектов))

    + Тест проверяет, что у нового объекта метаданных задано одно из следующих свойств: "Представление объекта", "Представление записи", "Представление списка".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный" name="Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный"></a>
+ **[1.13.](#тесты) Проверка [реквизитов документов: комментарий, ответственный](https://its.1c.ru/db/v8std#content:719:hdoc)** 
([Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный](./Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный))

    + Тест проверяет, что у документов есть реквизиты: "Комментарий", "Ответственный".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [ПропускатьОбъектыСПрефиксомУдалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)
        - ОпределяемыйТипКомментарий - Имя определяемого типа "Комментарий" для проверки типа реквизита "Комментарий" документов. Настройка задается свойством "ОпределяемыйТипКомментарий": "ИмяОпределяемогоТипаКомментарий".
        - ОпределяемыйТипОтветственный - Имя определяемого типа "Ответственный" для проверки типа реквизита "Ответственный" документов. Настройка задается свойством "ОпределяемыйТипОтветственный": "ИмяОпределяемогоТипаОтветственный".

<a id="markdown-Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс" name="Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс"></a>
+ **[1.14.](#тесты) Проверка включения объектов в [командный интерфейс](https://its.1c.ru/db/v8std#content:543:hdoc)** 
([Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс](./Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс))

    + Тест проверяет, что объекты конфигурации включены в командный интерфейс или в служебные подсистемы.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-тесты_внутренние_стандарты" name="тесты_внутренние_стандарты"></a>

### [2.](#тесты) Тесты для проверки объектов метаданных на соответствие внутренним стандартам
<a id="markdown-Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах" name="Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах"></a>
+ **[2.1.](#тесты) Проверка префикса в новых объектах и реквизитах** 
([Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах](./Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах))

    + Тест проверяет, что у нового объекта метаданных или реквизита установлен префикс.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Конфигурация поставщика](#Настройки_КонфигурацияПоставщика)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему" name="Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему"></a>
+ **[2.2.](#тесты) Проверка включения новых объектов с префиксом в подсистему** 
([Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему](./Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему))

    + Тест проверяет, что новый объект метаданных с префиксом включен в подсистему.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Префикс](#Настройки_Префикс)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [Подсистема](#Настройки_Подсистема)

<a id="markdown-Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом" name="Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом"></a>
+ **[2.3.](#тесты) Проверка синонима новых объектов и реквизитов** 
([Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом](./Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом))

    + Тест проверяет, что у новых объектов и свойств метаданных синоним не содержит префикса.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов" name="Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов"></a>
+ **[2.4.](#тесты) Проверка префикса свойств новых объектов** 
([Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов](./Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов))

    + Тест проверяет, что у новых с (префиксом) объектов метаданных табличные части и свойства не содержат префикса.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаОсновныхФормОтчетов" name="Тесты_ПроверкаОсновныхФормОтчетов"></a>
+ **[2.5.](#тесты) Проверка основных форм отчетов** 
([Тесты_ПроверкаОсновныхФормОтчетов](./Тесты_ПроверкаОсновныхФормОтчетов))

    + Тест проверяет, что у отчетов или конфигурации установлены основные формы: "ОсновнаяФорма/ОсновнаяФормаОтчета", "ОсновнаяФормаНастроек/ОсновнаяФормаНастроекОтчета", "ОсновнаяФормаВарианта/ОсновнаяФормаВариантаОтчета".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [ПропускатьОбъектыСПрефиксомУдалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [Каталоги внешних отчетов](#Настройки_КаталогиВнешнихОтчетов)
        - [Форма отчета](#Настройки_ФормаОтчета)
        - [Форма настроек](#Настройки_ФормаНастроекОтчета)
        - [Форма варианта](#Настройки_ФормаВариантаОтчета)

<a id="markdown-Тесты_ПроверкаХранилищаВариантовОтчетов" name="Тесты_ПроверкаХранилищаВариантовОтчетов"></a>
+ **[2.6.](#тесты) Проверка хранилища вариантов отчетов** 
([Тесты_ПроверкаХранилищаВариантовОтчетов](./Тесты_ПроверкаХранилищаВариантовОтчетов))

    + Тест проверяет, что у отчетов или конфигурации установлено хранилище вариантов отчетов.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [ПропускатьОбъектыСПрефиксомУдалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [Каталоги внешних отчетов](#Настройки_КаталогиВнешнихОтчетов)
        - [Хранилище вариантов отчетов](#Настройки_ХранилищеВариантовОтчетов)

<a id="markdown-Тесты_ПроверкаПравНаЧтениеОбъектовRLS" name="Тесты_ПроверкаПравНаЧтениеОбъектовRLS"></a>
+ **[2.7.](#тесты) Проверка прав на чтение объектов с RLS** 
([Тесты_ПроверкаПравНаЧтениеОбъектовRLS](./Тесты_ПроверкаПравНаЧтениеОбъектовRLS))

    + Тест проверяет, что у неосновных ролей нет права чтение объектов метаданных без RLS.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [Объекты метаданных](#Настройки_ОбъектыМетаданных)
        
<a id="markdown-Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок" name="Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок"></a>
+ **[2.8.](#тесты) Проверка макетов СКД внешних отчетов и обработок** 
([Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок](./Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок))

    + Тест проверяет макет СКД у внешних отчетов и обработок.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [Каталоги внешних отчетов](#Настройки_КаталогиВнешнихОтчетов)
        - [Каталоги внешних обработок](#Настройки_КаталогиВнешнихОбработок)

<a id="markdown-Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика" name="Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика"></a>
+ **[2.9.](#тесты) Проверка объектов метаданных конфигурации поставщика** 
([Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика](./Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика))

    + Тест проверяет, что объекты метаданных конфигурации поставщика не были удалены из конфигурации.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Конфигурация поставщика](#Настройки_КонфигурацияПоставщика)
        
<a id="markdown-Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств" name="Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств"></a>
+ **[2.10.](#тесты) Проверка каноничности префикса новых объектов и реквизитов** 
([Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств](./Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств))

    + Тест проверяет, что префикс новых объектов метаданных соответствует каноничному написанию.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных" name="Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных"></a>
+ **[2.11.](#тесты) Проверка индексирования устаревших объектов метаданных** 
([Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных](./Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных))

    + Тест проверяет, что у устаревших объектов метаданных отключено индексирование свойств.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаУстаревшихТиповДанных" name="Тесты_ПроверкаУстаревшихТиповДанных"></a>
+ **[2.12.](#тесты) Проверка устаревших типов данных** 
([Тесты_ПроверкаУстаревшихТиповДанных](./Тесты_ПроверкаУстаревшихТиповДанных))

    + Тест проверяет, что у реквизитов и свойств объектов метаданных с устаревшим типом данных установлен префикс имени "Удалить" и префикс синонима "(не используется)".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПроверкаАвтоРегистрацииПлановОбмена" name="Тесты_ПроверкаАвтоРегистрацииПлановОбмена"></a>
+ **[2.13.](#тесты) Проверка авторегистрации планов обмена** 
([Тесты_ПроверкаАвтоРегистрацииПлановОбмена](./Тесты_ПроверкаАвтоРегистрацииПлановОбмена))

    + Тест проверяет, что у объектов метаданных входящих в состав планов обмена отключена авторегистрация.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)

<a id="markdown-Тесты_ПереходНаУправляемыеФормы" name="Тесты_ПереходНаУправляемыеФормы"></a>
+ **[2.14.](#тесты) Переход на управляемые формы** 
([Тесты_ПереходНаУправляемыеФормы](./Тесты_ПереходНаУправляемыеФормы))

    + Тест проверяет, что все формы конфигурации управляемые.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [ПропускатьОбъектыСПрефиксомУдалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)

<a id="markdown-Тесты_ПроверкаПериодичностиНумерацииДокументов" name="Тесты_ПроверкаПериодичностиНумерацииДокументов"></a>
+ **[2.15.](#тесты) Проверка периодичности нумерации документов** 
([Тесты_ПроверкаПериодичностиНумерацииДокументов](./Тесты_ПроверкаПериодичностиНумерацииДокументов))

    + Тест проверяет, что у всех документов в конфигурации установлена периодическая нумерация.
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [ПропускатьОбъектыСПрефиксомУдалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)

<a id="markdown-Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента" name="Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента"></a>
+ **[2.16.](#тесты) Проверка регистров для отчета ["Движения документа"](https://its.1c.ru/db/bsp246doc#content:50:1)** 
([Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента](./Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента))

    + Тест проверяет, что у регистров подчиненных регистратору:
        * Выключено использование стандартных команд.
        * Указана основная форма списка.
        * Основная форма списка - управляемая.
        * В форме списка есть колонка "Регистратор".
    + Настройки:
        - [Используется](#Настройки_Используется)
        - [Выводить исключения](#Настройки_ВыводитьИсключения)
        - [Префикс](#Настройки_Префикс)
        - [Отбор по префиксу](#Настройки_ОтборПоПрефиксу)
        - [Исключения из проверок](#Настройки_ИсключенияИзПроверок)
        - [ПропускатьОбъектыСПрефиксомУдалить](#Настройки_ПропускатьОбъектыСПрефиксомУдалить)

<a id="markdown-шаблон_теста" name="шаблон_теста"></a>

### [3.](#тесты) Шаблон теста.

+ **[3.1.](#тесты) Шаблон теста** ([Тесты_ШаблонТеста](./Тесты_ШаблонТеста))

    + Шаблон теста для создания новых тестов.

<a id="markdown-настройка" name="настройка"></a>
## Настройка тестов

Настройки тестов задаются в файле xUnitparams.json ([пример](./tools/JSON/xUnitParams.json)).

<a id="markdown-Настройки_Используется" name="Настройки_Используется"></a>
+ **"Используется"** - Включает/отключает использование теста. Настройка задается свойством "Используется": true/false. Настройка доступна для тестов:

    - **[Тесты_ПроверкаАвтоРегистрацииПлановОбмена](#Тесты_ПроверкаАвтоРегистрацииПлановОбмена)**
    - **[Тесты_ПереходНаУправляемыеФормы](#Тесты_ПереходНаУправляемыеФормы)**
    - **[Тесты_ПроверкаПериодичностиНумерацииДокументов](#Тесты_ПроверкаПериодичностиНумерацииДокументов)**
    - **[Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный](#Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный)**
    - **[Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных](#Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаСтандартныхРолей](#Тесты_ПроверкаСтандартныхРолей)**
    - **[Тесты_ПроверкаОбщихРеквизитов](#Тесты_ПроверкаОбщихРеквизитов)**
    - **[Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс](#Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс)**
    - **[Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных](#Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектов](#Тесты_ПроверкаПравНаЧтениеОбъектов)**
    - **[Тесты_ПроверкаПраваИнтерактивногоУдаления](#Тесты_ПроверкаПраваИнтерактивногоУдаления)**
    - **[Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных](#Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных)**
    - **[Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов](#Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов)**
    - **[Тесты_ПроверкаСоставныхТиповДанных](#Тесты_ПроверкаСоставныхТиповДанных)**
    - **[Тесты_ПроверкаРегламентныхЗаданий](#Тесты_ПроверкаРегламентныхЗаданий)**
    - **[Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента](#Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента)**
    - **[Тесты_ПроверкаПользовательскихПредставленийОбъектов](#Тесты_ПроверкаПользовательскихПредставленийОбъектов)**
    - **[Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом](#Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом)**
    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**
    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**
    - **[Тесты_ПроверкаПривилегированногоРежимаОбъектов](#Тесты_ПроверкаПривилегированногоРежимаОбъектов)**
    - **[Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств](#Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств)**
    - **[Тесты_ПроверкаПравКУстаревшимОбъектам](#Тесты_ПроверкаПравКУстаревшимОбъектам)**
    - **[Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок](#Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектовRLS](#Тесты_ПроверкаПравНаЧтениеОбъектовRLS)**
    - **[Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему](#Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему)**
    - **[Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах](#Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах)**
    - **[Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов](#Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов)**
    - **[Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика](#Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика)**
    - **[Тесты_ПроверкаУстаревшихТиповДанных](#Тесты_ПроверкаУстаревшихТиповДанных)**

<a id="markdown-Настройки_ВыводитьИсключения" name="Настройки_ВыводитьИсключения"></a>
+ **"ВыводитьИсключения"** - Включает/отключает вывод исключений для теста. Настройка задается свойством "ВыводитьИсключения": true/false. Настройка доступна для тестов:

    - **[Тесты_ПроверкаАвтоРегистрацииПлановОбмена](#Тесты_ПроверкаАвтоРегистрацииПлановОбмена)**
    - **[Тесты_ПереходНаУправляемыеФормы](#Тесты_ПереходНаУправляемыеФормы)**
    - **[Тесты_ПроверкаПериодичностиНумерацииДокументов](#Тесты_ПроверкаПериодичностиНумерацииДокументов)**
    - **[Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный](#Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный)**
    - **[Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных](#Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаСтандартныхРолей](#Тесты_ПроверкаСтандартныхРолей)**
    - **[Тесты_ПроверкаОбщихРеквизитов](#Тесты_ПроверкаОбщихРеквизитов)**
    - **[Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс](#Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс)**
    - **[Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных](#Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектов](#Тесты_ПроверкаПравНаЧтениеОбъектов)**
    - **[Тесты_ПроверкаСоставныхТиповДанных](#Тесты_ПроверкаСоставныхТиповДанных)**
    - **[Тесты_ПроверкаРегламентныхЗаданий](#Тесты_ПроверкаРегламентныхЗаданий)**
    - **[Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента](#Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента)**
    - **[Тесты_ПроверкаПользовательскихПредставленийОбъектов](#Тесты_ПроверкаПользовательскихПредставленийОбъектов)**
    - **[Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом](#Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом)**
    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**
    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**
    - **[Тесты_ПроверкаПривилегированногоРежимаОбъектов](#Тесты_ПроверкаПривилегированногоРежимаОбъектов)**
    - **[Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств](#Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств)**
    - **[Тесты_ПроверкаПравКУстаревшимОбъектам](#Тесты_ПроверкаПравКУстаревшимОбъектам)**
    - **[Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок](#Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектовRLS](#Тесты_ПроверкаПравНаЧтениеОбъектовRLS)**
    - **[Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему](#Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему)**
    - **[Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах](#Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах)**
    - **[Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов](#Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов)**
    - **[Тесты_ПроверкаУстаревшихТиповДанных](#Тесты_ПроверкаУстаревшихТиповДанных)**

<a id="markdown-Настройки_Префикс" name="Настройки_Префикс"></a>
+ **"Префикс"** - Префикс для новых объектов и свойств метаданных. Настройка задается свойством "Префикс": "МойПрефикс". Настройка доступна для тестов:

    - **[Тесты_ПроверкаАвтоРегистрацииПлановОбмена](#Тесты_ПроверкаАвтоРегистрацииПлановОбмена)**
    - **[Тесты_ПереходНаУправляемыеФормы](#Тесты_ПереходНаУправляемыеФормы)**
    - **[Тесты_ПроверкаПериодичностиНумерацииДокументов](#Тесты_ПроверкаПериодичностиНумерацииДокументов)**
    - **[Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный](#Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный)**
    - **[Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных](#Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаОбщихРеквизитов](#Тесты_ПроверкаОбщихРеквизитов)**
    - **[Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс](#Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс)**
    - **[Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных](#Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектов](#Тесты_ПроверкаПравНаЧтениеОбъектов)**
    - **[Тесты_ПроверкаСоставныхТиповДанных](#Тесты_ПроверкаСоставныхТиповДанных)**
    - **[Тесты_ПроверкаРегламентныхЗаданий](#Тесты_ПроверкаРегламентныхЗаданий)**
    - **[Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента](#Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента)**
    - **[Тесты_ПроверкаПользовательскихПредставленийОбъектов](#Тесты_ПроверкаПользовательскихПредставленийОбъектов)**
    - **[Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом](#Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом)**
    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**
    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**
    - **[Тесты_ПроверкаПривилегированногоРежимаОбъектов](#Тесты_ПроверкаПривилегированногоРежимаОбъектов)**
    - **[Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств](#Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств)**
    - **[Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему](#Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему)**
    - **[Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах](#Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах)**
    - **[Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов](#Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов)**
    - **[Тесты_ПроверкаУстаревшихТиповДанных](#Тесты_ПроверкаУстаревшихТиповДанных)**

<a id="markdown-Настройки_ПропускатьОбъектыСПрефиксомУдалить" name="Настройки_ПропускатьОбъектыСПрефиксомУдалить"></a>
+ **"ПропускатьОбъектыСПрефиксомУдалить"** - Признак того, что тест будет пропускать объекты с префиксом "Удалить". Настройка задается свойством "ПропускатьОбъектыСПрефиксомУдалить": true/false. Настройка доступна для тестов:

    - **[Тесты_ПереходНаУправляемыеФормы](#Тесты_ПереходНаУправляемыеФормы)**
    - **[Тесты_ПроверкаПериодичностиНумерацииДокументов](#Тесты_ПроверкаПериодичностиНумерацииДокументов)**
    - **[Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный](#Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектов](#Тесты_ПроверкаПравНаЧтениеОбъектов)**
    - **[Тесты_ПроверкаСоставныхТиповДанных](#Тесты_ПроверкаСоставныхТиповДанных)**
    - **[Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента](#Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента)**
    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**
    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**

<a id="markdown-Настройки_ИсключенияИзПроверок" name="Настройки_ИсключенияИзПроверок"></a>
+ **"ИсключенияИзПроверок"** - Исключения из проверок с типом структура. Задается как список свойств структуры, где ключ - это имя объекта метаданных в единственном числе ("Документ", "Справочник"), а значение - это массив имен подчиненных объектов ("Справочник1", "Документ1", "Справочник1.ТабличнаяЧасть.Товары", "Документ1.Форма.ФормаДокумента" и т.д.). Настройка доступна для тестов:

    - **[Тесты_ПроверкаПользовательскихПредставленийОбъектов](#Тесты_ПроверкаПользовательскихПредставленийОбъектов)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектов](#Тесты_ПроверкаПравНаЧтениеОбъектов)**
    - **[Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах](#Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах)**
    - **[Тесты_ПроверкаСоставныхТиповДанных](#Тесты_ПроверкаСоставныхТиповДанных)**
    - **[Тесты_ПроверкаСтандартныхРолей](#Тесты_ПроверкаСтандартныхРолей)**
    - **[Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных](#Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаПривилегированногоРежимаОбъектов](#Тесты_ПроверкаПривилегированногоРежимаОбъектов)**
    - **[Тесты_ПроверкаОбщихРеквизитов](#Тесты_ПроверкаОбщихРеквизитов)**
    - **[Тесты_ПроверкаРегламентныхЗаданий](#Тесты_ПроверкаРегламентныхЗаданий)**
    - **[Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом](#Тесты_ПроверкаСинонимаОбъектовИСвойствСПрефиксом)**
    - **[Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов](#Тесты_ПроверкаПрефиксаСвойствНовыхОбъектов)**
    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**
    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**
    - **[Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный](#Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный)**
    - **[Тесты_ПроверкаПравНаЧтениеОбъектовRLS](#Тесты_ПроверкаПравНаЧтениеОбъектовRLS)**
    - **[Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств](#Тесты_ПроверкаКаноничностиПрефиксаОбъектовСвойств)**
    - **[Тесты_ПроверкаПравКУстаревшимОбъектам](#Тесты_ПроверкаПравКУстаревшимОбъектам)**
    - **[Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных](#Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаУстаревшихТиповДанных](#Тесты_ПроверкаУстаревшихТиповДанных)**
    - **[Тесты_ПроверкаАвтоРегистрацииПлановОбмена](#Тесты_ПроверкаАвтоРегистрацииПлановОбмена)**
    - **[Тесты_ПереходНаУправляемыеФормы](#Тесты_ПереходНаУправляемыеФормы)**
    - **[Тесты_ПроверкаПериодичностиНумерацииДокументов](#Тесты_ПроверкаПериодичностиНумерацииДокументов)**
    - **[Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс](#Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс)**
    - **[Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента](#Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента)**
    - **[Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок](#Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок)**
    - **[Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему](#Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему)**

<a id="markdown-Настройки_ОсновныеРоли" name="Настройки_ОсновныеРоли"></a>
+ **ОсновныеРоли** - Описание основных ролей конфигурации. Задается как массив имен ролей, которые входят в список свойства конфигурации **"Основные роли конфигурации"**. Настройка доступна для тестов:

    - **[Тесты_ПроверкаСтандартныхРолей](#Тесты_ПроверкаСтандартныхРолей)**

<a id="markdown-Настройки_СтандартныеРоли" name="Настройки_СтандартныеРоли"></a>
+ **СтандартныеРоли** - Описание стандартных ролей конфигурации. Задается как список свойств структуры, где ключ - это имя стандартной роли, значение - это массив строк с именем прав на корень конфигурации. Настройка доступна для тестов:

    - **[Тесты_ПроверкаСтандартныхРолей](#Тесты_ПроверкаСтандартныхРолей)**

<a id="markdown-Настройки_ПроверятьДополнительныеРеквизиты" name="Настройки_ПроверятьДополнительныеРеквизиты"></a>
+ **ПроверятьДополнительныеРеквизиты** - Признак, что будут проверяться дополнительные реквизиты и сведения. Настройка задается в разделе "ИмяТеста" свойством "ПроверятьДополнительныеРеквизиты": true/false. Настройка доступна для тестов:

    - **[Тесты_ПроверкаСоставныхТиповДанных](#Тесты_ПроверкаСоставныхТиповДанных)**

<a id="markdown-Настройки_ОтборПоПрефиксу" name="Настройки_ОтборПоПрефиксу"></a>
+ **ОтборПоПрефиксу** - Признак, что будут проверяться только объекты с префиксом, указанным в параметре **"Префикс"**. Настройка задается в разделе "ИмяТеста" свойством "ОтборПоПрефиксу": true/false. Настройка доступна для тестов:

    - **[Тесты_ПроверкаПравНаЧтениеОбъектов](#Тесты_ПроверкаПравНаЧтениеОбъектов)**
    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**
    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**
    - **[Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный](#Тесты_ПроверкаРеквизитовДокументовКомментарийОтветственный)**
    - **[Тесты_ПроверкаРегламентныхЗаданий](#Тесты_ПроверкаРегламентныхЗаданий)**
    - **[Тесты_ПроверкаСоставныхТиповДанных](#Тесты_ПроверкаСоставныхТиповДанных)**
    - **[Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных](#Тесты_ПроверкаСинонимаУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных](#Тесты_ПроверкаИндексированияУстаревшихОбъектовМетаданных)**
    - **[Тесты_ПроверкаУстаревшихТиповДанных](#Тесты_ПроверкаУстаревшихТиповДанных)**
    - **[Тесты_ПроверкаАвтоРегистрацииПлановОбмена](#Тесты_ПроверкаАвтоРегистрацииПлановОбмена)**
    - **[Тесты_ПереходНаУправляемыеФормы](#Тесты_ПереходНаУправляемыеФормы)**
    - **[Тесты_ПроверкаПериодичностиНумерацииДокументов](#Тесты_ПроверкаПериодичностиНумерацииДокументов)**
    - **[Тесты_ПроверкаОбщихРеквизитов](#Тесты_ПроверкаОбщихРеквизитов)**
    - **[Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс](#Тесты_ПроверкаВключенияОбъектовВКомандныйИнтерфейс)**
    - **[Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента](#Тесты_ПроверкаРегистровДляОтчетаДвиженияДокумента)**
    - **[Тесты_ПроверкаПользовательскихПредставленийОбъектов](#Тесты_ПроверкаПользовательскихПредставленийОбъектов)**
    - **[Тесты_ПроверкаПривилегированногоРежимаОбъектов](#Тесты_ПроверкаПривилегированногоРежимаОбъектов)**

<a id="markdown-Настройки_ХранилищеВариантовОтчетов" name="Настройки_ХранилищеВариантовОтчетов"></a>
+ **ХранилищеВариантовОтчетов** - Имя хранилища вариантов отчетов. Настройка задается в разделе теста свойством "ХранилищеВариантовОтчетов": "Имя хранилища вариантов отчетов". Настройка доступна для тестов:

    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**

<a id="markdown-Настройки_ФормаОтчета" name="Настройки_ФормаОтчета"></a>
+ **ФормаОтчета** - Имя общей формы отчета. Настройка задается в разделе теста свойством "ФормаОтчета": "Имя формы отчета". Настройка доступна для тестов:

    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**

<a id="markdown-Настройки_ФормаНастроекОтчета" name="Настройки_ФормаНастроекОтчета"></a>
+ **ФормаНастроек** - Имя общей формы настроек отчета. Настройка задается в разделе теста свойством "ФормаНастроек": "Имя формы настроек отчета". Настройка доступна для тестов:

    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**

<a id="markdown-Настройки_ФормаВариантаОтчета" name="Настройки_ФормаВариантаОтчета"></a>
+ **ФормаВарианта** - Имя общей формы вариантов отчета. Настройка задается в разделе теста свойством "ФормаВарианта": "Имя формы вариантов отчета". Настройка доступна для тестов:

    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**

<a id="markdown-Настройки_ОбъектыМетаданных" name="Настройки_ОбъектыМетаданных"></a>
+ **ОбъектыМетаданных** - Список объектов метаданных для проверки. Настройка задается в разделе "Тесты_ПроверкаПравНаЧтениеОбъектовRLS" как список свойств структуры, где ключ - это имя объекта метаданных в единственном числе ("Документ", "Справочник"), а значение - это массив имен подчиненных объектов ("Справочник1", "Документ1" и т.д.) или строка с одним символом **"*"** (будут выбраны все объекты коллекции: все справочники, все документы и т.д.). Настройка доступна для тестов:

    - **[Тесты_ПроверкаПравНаЧтениеОбъектовRLS](#Тесты_ПроверкаПравНаЧтениеОбъектовRLS)**
   
<a id="markdown-Настройки_КаталогиВнешнихОтчетов" name="Настройки_КаталогиВнешнихОтчетов"></a> 
+ **КаталогиВнешнихОтчетов** - Список каталогов с внешними отчетами. Настройка задается в разделе "ИмяТеста" как массив строк с именами каталогов (можно указывать как относительный путь). Настройка доступна для тестов:
 
    - **[Тесты_ПроверкаОсновныхФормОтчетов](#Тесты_ПроверкаОсновныхФормОтчетов)**
    - **[Тесты_ПроверкаХранилищаВариантовОтчетов](#Тесты_ПроверкаХранилищаВариантовОтчетов)**
    - **[Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок](#Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок)**

<a id="markdown-Настройки_КаталогиВнешнихОбработок" name="Настройки_КаталогиВнешнихОбработок"></a> 
+ **КаталогиВнешнихОбработок** - Список каталогов с внешними обработкаим. Настройка задается в разделе "Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок" как массив строк с именами каталогов (можно указывать как относительный путь). Настройка доступна для тестов:
 
    - **[Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок](#Тесты_ПроверкаМакетовСКДВнешнихОтчетовОбработок)**

<a id="markdown-Настройки_ПроверятьОсновныеРоли" name="Настройки_ПроверятьОсновныеРоли"></a> 
+ **ПроверятьОсновныеРоли** - Признак того, что тест будет проверять основные роли конфигурации. Настройка задается свойством "ПроверятьОсновныеРоли": true/false. Настройка доступна для тестов:
 
    - **[Тесты_ПроверкаПраваИнтерактивногоУдаления](#Тесты_ПроверкаПраваИнтерактивногоУдаления)**
    - **[Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных](#Тесты_ПроверкаПраваИнтерактивногоУдаленияПомеченных)**
    - **[Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов](#Тесты_ПроверкаПравНаПредопределенныеДанныеОбъектов)**

<a id="markdown-Настройки_Подсистема" name="Настройки_Подсистема"></a>
+ **"Подсистема"** - Подсистема, в которую добавляются новые объекты метаданных. Настройка задается свойством "Подсистема": "ИмяПодсистемы". Настройка доступна для тестов:

    - **[Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему](#Тесты_ПроверкаВключенияОбъектовСПрефиксомВПодсистему)**

<a id="markdown-Настройки_КонфигурацияПоставщика" name="Настройки_КонфигурацияПоставщика"></a>
+ **"КонфигурацияПоставщика"** - Путь к файлу со структурой конфигурации поставщика ([пример файла](../../tools/JSON/providerConfiguration.json)). Настройка задается свойством "КонфигурацияПоставщика": "ПолноеИмяФайла.json" (можно указывать как относительный путь к файлу). Файл конфигурации поставщика можно получить путем интерактивного запуска обработки **[Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах](./Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах)**, и с помощью команды "Выбор файла" открыть файл отчета конфигурации поставщика в текстовом формате. Файл "ОтчетПоКонфигурации.txt" можно получить в конфигураторе: открыть конфигурацию поставщика, выполнить команду Конфигурация/Отчет по конфигурации/Выводить в текстовый документ. Настройка доступна для тестов:

    - **[Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах](#Тесты_ПроверкаПрефиксаВНовыхОбъектахИРеквизитах)**
    - **[Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика](#Тесты_ПроверкаОбъектовМетаданныхКонфигурацииПоставщика)**
