# Файлы настройки пакетного запуска из командной строки

В текущем каталоге указаны файлы настройки запуска

* [vrunner.json](vrunner.json) - пример настройки пакетного запуска тестов для Vanessa-Runner
* [xUnitParams.json](xUnitParams.json) - пример настройки запуска дымовых тестов для xddTestRunner
* [tools\JSON\VBParams8310UF.json](VBParams8310UF.json) - пример настройки проверки поведения для bddRunner

## Описание передачи параметров для bddRunner

Пути к внутренним файлам задаются относительно каталога tools
Например:

```
   ./JSON/VBParams8310UF.json
```

### Пример json-файла для одной сборки

```json
{
   "ИмяСборки":"Сборка 8.3",
   "КаталогПоискаВерсииПлатформы":"C:\\Program Files (x86)\\1cv8",
   "ПутьКVanessaADD": "./bddRunner.epf",

   "КаталогПроекта": "$workspaceRoot",
   "КаталогФич": "$workspaceRoot/features",
   "КаталогиБиблиотек": [
      "$instrumentsRoot/features/libraries"
   ],
   "КаталогВнешнихОбработокEDT": "$workspaceRoot/features/Drafts/step_definitions/bin",

   "ВыполнитьСценарии": true,
   "ЗавершитьРаботуСистемы": true,
   "ЗакрытьTestClientПослеЗапускаСценариев": true,
   "ПриравниватьPendingКFailed": false,
   "ВыводитьВЛогВыполнениеШагов": true,

   "ВыгружатьСтатусВыполненияСценариевВФайл": true,
   "ПутьКФайлуДляВыгрузкиСтатусаВыполненияСценариев": "$workspaceRoot/./ServiceBases/BuildStatus.log",

   "ДелатьЛогВыполненияСценариевВТекстовыйФайл": true,
   "ИмяФайлаЛогВыполненияСценариев": "$workspaceRoot/./ServiceBases/log.txt",
   "ПутьКФайлуДляВыгрузкиСтатусаВыполненияСценариев": "./distr/BuildStatus.log",

   "ДелатьЛогВыполненияСценариевВЖР": true,

   "ДелатьОтчетВФорматеjUnit": true,
   "КаталогOutputjUnit": "$workspaceRoot/./ServiceBases/junitreport",

   "ДелатьОтчетВФорматеАллюр": true,
   "КаталогOutputAllureБазовый": "./distr/allurereport",
   "СоздаватьПодкаталогВКаталогеAllureДляЭтойСборки": true,
   "ДобавлятьКИмениСценарияУсловияВыгрузки": true,

   "ДелатьСкриншотПриВозникновенииОшибки": true,
   "КаталогOutputСкриншоты": "./ServiceBases/ScreenShots",
   "КомандаСделатьСкриншот": "\"C:\\Program Files (x86)\\IrfanView\\i_view32.exe\" /capture=1 /convert=",

   "ДополнительныеПараметры": {
        "КаталогФичДляVBManager": "$workspaceRoot/./features"
    },

   "СписокТеговИсключение":[
      "IgnoreOnCIMainBuild",
      "IgnoreOn82Builds",
      "IgnoreOnOFBuilds"
   ],

   "EpfДляИнициализацияБазы": "./epf/init.epf",
   "ПараметрыДляИнициализацияБазы": "./epf/init.json"
}
```

### Значения параметров

* КаталогФич - каталог, откуда будут загружены фичи
* КаталогиБиблиотек - массив строк. Каталоги библиотек.

* ИмяСборки - это имя будет использовано для того, чтобы идентифицировать Сборка среди других в отчете Allure и jUnit. Будет создан каталог, поэтому нельзя использовать запрещенные символы файловой системы.
* ВерсияПлатформы - может быть в краткой форме, например 8.2 или 8.3 и т.д. или в более точной, например 8.3.6 или 8.3.6.1111. Для краткой формы будет взята самая свежая версия платформы.
* КаталогПоискаВерсииПлатформы - каталог, где надо искать версии платформы 1С
* ПутьКVanessaADD - путь к bddRunner.epf
* СтрокаПодключенияКБазе - Строка подкчлючения к базе

* ВыполнитьСценарии - флаг того, что будут выполнены сценарии
* ЗавершитьРаботуСистемы - флаг того, что после выполнения сценариев будет закрыт сеанс 1С, в котором шел запуск сценариев
* ЗакрытьTestClientПослеЗапускаСценариев - закроет сеанс TestClient если он остался незакрытым
* ДелатьЛогВыполненияСценариевВЖР - флаг того, что перед каждым сценарием и шагом будет создана запись в ЖР. Помогает при падении платформы с дампом.
* ВыводитьСообщенияВФайл - необязательный. Если указан - то будет выводится окно сообщений в файл, указанный в параметре.
* ВыгружатьСтатусВыполненияСценариевВФайл - флаг, что будет создан файл со статусом всего Сборки. 0 - успешно, 1 - не успешно.
* ПутьКФайлуДляВыгрузкиСтатусаВыполненияСценариев - путь к файлу описанному ранее

* ДелатьОтчетВФорматеАллюр - флаг того, что будут формировться xml файлы для отчета Allurе
* КаталогOutputAllureБазовый - в этом каталоге будут формироваться подкаталоги вида <ИмяСборки>, в которых будут лежать результаты прохождения сценариев в формате xml
* СоздаватьПодкаталогВКаталогеAllureДляЭтойСборки - флаг нужен для варианта отчета Allure, когда все сценарии хранятся не иерархически и когда, например, происходит проверка сценариев на разных версиях платформы
* ДобавлятьКИмениСценарияУсловияВыгрузки - флаг нужен для того, чтобы в финальном отчете можно было отличать сценарии, если мы проверяем их больше чем в одном Сборкае

* СписокТеговИсключение - массив строк. Если в фиче есть такой тег, то она не будет загружена на выполнение.

* ДелатьСкриншотПриВозникновенииОшибки - флаг того что при возникновении ошибки будут делаться скриншоты
* КаталогOutputСкриншоты - каталог, куда будут делаться скриншоты
* КомандаСделатьСкриншот - Команда, которая будет выполнятся для снятия скриншота

* EpfДляИнициализацияБазы - необязательный параметр. Это обработка, которая будет инициализировать БД.
* ПараметрыДляИнициализацияБазы - необязательный параметр. Это json файл, который надо будет прочитать в обработке по инициализации базы.
* ЗапускатьТолстыйКлиент - будет запущен файл 1cv8.exe вместо 1cv8c.exe

* КаталогСкриптовСборкиВидео - каталог, где лежат скрипты сборки видео
* СоздаватьИнструкциюВидео - флаг того, что надо делать видео инструкцию
* КаталогOutputИнструкцияВидео - каталог, где окажется записанный видеоролик
